Loading...
Searching...
No Matches
juce::ArgumentList Struct Reference

## Detailed Description

Holds a list of command-line arguments, and provides useful methods for searching and operating on them.

You can create an ArgumentList manually, or give it some argv/argc values from a main() function to parse.

See also
  ConsoleApplication

The documentation for this struct was generated from the following file:

- juce_core/misc/juce_ConsoleApplication.h

## Classes

struct | Argument
| One of the arguments in an ArgumentList. More...

## Public Member Functions

| ArgumentList (String executable, StringArray arguments)
| Creates an argument list for a given executable.
| ArgumentList (int argc, char *argv[])
| Parses a standard argv/argc pair to create an argument list.
| ArgumentList (const String &executable, const String &arguments)
| Tokenises a string containing all the arguments to create an argument list.
| ArgumentList (const ArgumentList &)=default
ArgumentList & | operator= (const ArgumentList &)=default
int | size () const
| Returns the number of arguments in the list.
Argument | operator[] (int index) const
| Returns one of the arguments.
void | checkMinNumArguments (int expectedMinNumberOfArgs) const
| Throws an error unless there are at least the given number of arguments.
bool | containsOption (StringRef option) const
| Returns true if the given string matches one of the arguments.
bool | removeOptionIfFound (StringRef option)
| Returns true if the given string matches one of the arguments, and also removes the argument from the list if found.
int | indexOfOption (StringRef option) const
| Returns the index of the given string if it matches one of the arguments, or -1 if it doesn't.
void | failIfOptionIsMissing (StringRef option) const
| Throws an error unless the given option is found in the argument list.
String | getValueForOption (StringRef option) const
| Looks for a given argument and returns either its assigned value (for long options) or the string that follows it (for short options).
String | removeValueForOption (StringRef option)
| Looks for a given argument and returns either its assigned value (for long options) or the string that follows it (for short options).
File | getFileForOption (StringRef option) const
| Looks for the value of argument using getValueForOption() and tries to parse that value as a file.
File | getFileForOptionAndRemove (StringRef option)
| Looks for the value of argument using getValueForOption() and tries to parse that value as a file.
File | getExistingFileForOption (StringRef option) const
| Looks for a file argument using getFileForOption() and fails with a suitable error if the file doesn't exist.
File | getExistingFileForOptionAndRemove (StringRef option)
| Looks for a file argument using getFileForOption() and fails with a suitable error if the file doesn't exist.
File | getExistingFolderForOption (StringRef option) const
| Looks for a filename argument using getFileForOption() and fails with a suitable error if the file isn't a folder that exists.
File | getExistingFolderForOptionAndRemove (StringRef option)
| Looks for a filename argument using getFileForOption() and fails with a suitable error if the file isn't a folder that exists.

## Public Attributes

String | executableName
| The name or path of the executable that was invoked, as it was specified on the command-line.
Array< Argument > | arguments
| The list of arguments (not including the name of the executable that was invoked).

## Constructors and Destructors

## ArgumentList() [1/4]

juce::ArgumentList::ArgumentList | ( | String | executable,
|  | StringArray | arguments )

Creates an argument list for a given executable.

References arguments.

Referenced by ArgumentList(), and operator=().

## ArgumentList() [2/4]

juce::ArgumentList::ArgumentList | ( | int | argc,
|  | char * | argv[] )

Parses a standard argv/argc pair to create an argument list.

## ArgumentList() [3/4]

juce::ArgumentList::ArgumentList | ( | const String & | executable,
|  | const String & | arguments )

Tokenises a string containing all the arguments to create an argument list.

References arguments.

## ArgumentList() [4/4]

juce::ArgumentList::ArgumentList | ( | const ArgumentList & |  | ) |

default

References ArgumentList().

## Member Functions

## operator=()

ArgumentList & juce::ArgumentList::operator= | ( | const ArgumentList & |  | ) |

default

References ArgumentList().

## size()

int juce::ArgumentList::size | ( |  | ) | const

Returns the number of arguments in the list.

## operator[]()

Argument juce::ArgumentList::operator[] | ( | int | index | ) | const

Returns one of the arguments.

## checkMinNumArguments()

void juce::ArgumentList::checkMinNumArguments | ( | int | expectedMinNumberOfArgs | ) | const

Throws an error unless there are at least the given number of arguments.

## containsOption()

bool juce::ArgumentList::containsOption | ( | StringRef | option | ) | const

Returns true if the given string matches one of the arguments.

The option can also be a list of different versions separated by pipes, e.g. "--help|-h"

See also
  removeOptionIfFound

## removeOptionIfFound()

bool juce::ArgumentList::removeOptionIfFound | ( | StringRef | option | ) |

Returns true if the given string matches one of the arguments, and also removes the argument from the list if found.

The option can also be a list of different versions separated by pipes, e.g. "--help|-h"

See also
  containsOption

## indexOfOption()

int juce::ArgumentList::indexOfOption | ( | StringRef | option | ) | const

Returns the index of the given string if it matches one of the arguments, or -1 if it doesn't.

The option can also be a list of different versions separated by pipes, e.g. "--help|-h"

## failIfOptionIsMissing()

void juce::ArgumentList::failIfOptionIsMissing | ( | StringRef | option | ) | const

Throws an error unless the given option is found in the argument list.

## getValueForOption()

String juce::ArgumentList::getValueForOption | ( | StringRef | option | ) | const

Looks for a given argument and returns either its assigned value (for long options) or the string that follows it (for short options).

The option can also be a list of different versions separated by pipes, e.g. "--help|-h" If it finds a long option, it will look for an assignment with a '=' sign, e.g. "--file=foo.txt", and will return the string following the '='. If there's no '=', it will return an empty string. If it finds a short option, it will attempt to return the argument that follows it, unless it's another option. If the argument isn't found, this returns an empty string.

## removeValueForOption()

String juce::ArgumentList::removeValueForOption | ( | StringRef | option | ) |

Looks for a given argument and returns either its assigned value (for long options) or the string that follows it (for short options).

This works like getValueForOption() but also removes the option argument (and any value arguments) from the list if they are found.

## getFileForOption()

File juce::ArgumentList::getFileForOption | ( | StringRef | option | ) | const

Looks for the value of argument using getValueForOption() and tries to parse that value as a file.

If the option isn't found, or if the value can't be parsed as a filename, it will throw an error.

## getFileForOptionAndRemove()

File juce::ArgumentList::getFileForOptionAndRemove | ( | StringRef | option | ) |

Looks for the value of argument using getValueForOption() and tries to parse that value as a file.

This works like getFileForOption() but also removes the option argument (and any value arguments) from the list if they are found.

## getExistingFileForOption()

File juce::ArgumentList::getExistingFileForOption | ( | StringRef | option | ) | const

Looks for a file argument using getFileForOption() and fails with a suitable error if the file doesn't exist.

## getExistingFileForOptionAndRemove()

File juce::ArgumentList::getExistingFileForOptionAndRemove | ( | StringRef | option | ) |

Looks for a file argument using getFileForOption() and fails with a suitable error if the file doesn't exist.

This works like getExistingFileForOption() but also removes the option argument (and any value arguments) from the list if they are found.

## getExistingFolderForOption()

File juce::ArgumentList::getExistingFolderForOption | ( | StringRef | option | ) | const

Looks for a filename argument using getFileForOption() and fails with a suitable error if the file isn't a folder that exists.

## getExistingFolderForOptionAndRemove()

File juce::ArgumentList::getExistingFolderForOptionAndRemove | ( | StringRef | option | ) |

Looks for a filename argument using getFileForOption() and fails with a suitable error if the file isn't a folder that exists.

This works like getExistingFolderForOption() but also removes the option argument (and any value arguments) from the list if they are found.

## Member Data Documentation

## executableName

String juce::ArgumentList::executableName

The name or path of the executable that was invoked, as it was specified on the command-line.

## arguments

Array<Argument> juce::ArgumentList::arguments

The list of arguments (not including the name of the executable that was invoked).

Referenced by ArgumentList(), and ArgumentList().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited